<template>
	<a-drawer
		:title="'电子锁预约审批'"
		:width="600"
		:visible="visible"
		:destroy-on-close="true"
		:footer-style="{ textAlign: 'right' }"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-form-item label="审批结果：" name="bankOpApprovalState">
				<a-radio-group v-model:value="formData.bankOpApprovalState" :options="[{label:'通过',value:'审批通过'},{label:'驳回',value:'审批驳回'}]"/>
			</a-form-item>
			<a-form-item label="审批备注：" name="bankOpApprovalRemark">
				<a-textarea v-model:value="formData.bankOpApprovalRemark" :auto-size="{ minRows: 3, maxRows: 10 }"/>
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</a-drawer>
</template>

<script setup name="depotLockBookForm">
import tool from '@/utils/tool'
import {cloneDeep} from 'lodash-es'
import {required} from '@/utils/formRules'
import depotLockBookApi from '@/api/biz/depotLockBookApi'
import dictOptionsApi from "@/api/biz/dictOptionsApi";
import depotGrainInfoApi from "@/api/biz/depotGrainInfoApi";
// 抽屉状态
const visible = ref(false)
const emit = defineEmits({successful: null})
const formRef = ref()
// 表单数据
const formData = ref({})
const submitLoading = ref(false)
const depotIdOptions = ref([])
const depotShedOptions = ref([])

// 打开抽屉
const onOpen = (record) => {
	visible.value = true
	if (record) {
		let recordData = cloneDeep(record)
		formData.value = Object.assign({}, recordData)
	}
	depotIdLoad()
}
// 关闭抽屉
const onClose = () => {
	formRef.value.resetFields()
	formData.value = {}
	visible.value = false
}
// 默认要校验的
const formRules = {
	bankOpApprovalState: [required('请选择')],
}
// 粮库加载
const depotIdLoad = () => {
	if (formData.value.depotId)
		dictOptionsApi.options({'dictValue': '库位', depotId: formData.value.depotId}).then((data) => {
			depotShedOptions.value = data
		})
}
// 验证并提交数据
const onSubmit = () => {
	formRef.value
		.validate()
		.then(() => {
			submitLoading.value = true
			const formDataParam = cloneDeep(formData.value)
			depotLockBookApi
				.bankOpApproval(formDataParam)
				.then(() => {
					onClose()
					emit('successful')
				})
				.finally(() => {
					submitLoading.value = false
				})
		})
}
// 抛出函数
defineExpose({
	onOpen
})
</script>
